set echo 0
set casesensitive 1
set exit 1

Set TempFile "{tempfolder}:camlmktop.temp.c"

set stdlib "LIBDIR"
set linkfiles ""
set custom ""
set customtype ""
Set cppc "CPPC"
set coptppc ""
set clinkppc "LINKPPC"
set clinkoptppc ""
set c68k "C68k"
set copt68k ""
set clink68k "LINK68k"
set clinkopt68k ""
set cfiles "`quote "{tempfile}"`"
Set objfiles "`quote "{tempfile}.o"`"
set output camltop.out
set p ""
set debug ""

set perv "baltree bool char eq exc fchar filename float format fstring fvect 
    gc genlex hashtbl int io iparsing lexing list map obj pair parsing 
    printexc printf queue random ref set sort stack stream string 
    toplevel vect"

loop
  break if {#} = 0
  if "{1}" =~ /()0.zo/
    set linkfiles "{linkfiles} {1}"
	set perv "{perv} {0}"
  else if "{1}" =~ /()0.zi/
    set perv "{perv} {0}"
  else if "{1}" == "-I" || "{1}" == "-include"
    set includes "{includes} -I {2}"
	shift
  else if "{1}" == "-o"
    set output "{2}"
	shift
  else if "{1}" =~ /-p/
    set perv "{perv} profiler"
	set p p
  else if "{1}" == "-stdlib"
    set stdlib "{2}"
	shift
  Else If "{1}" == "-custom"
    Set custom "-custom `quote "{tempfile}"`"
	set customtype fat
  Else If "{1}" == "-custom68k"
    Set custom "-custom `quote "{tempfile}"`"
	set customtype 68k
  Else If "{1}" == "-customPPC"
    Set custom "-custom `quote "{tempfile}"`"
	set customtype PPC
  else if "{1}" == "-g" || "{1}" == "-debug"
    set debug -g
  Else If "{1}" =~ /.c/
    Set cfiles "{cfiles} `quote "{1}"`"
	set objfiles "{objfiles} `quote "{1}.o"`"
  else if "{1}" =~ /.o/ || "{1}" =~ /[Ll]ib/
    if "{customtype}" == fat
      echo "cannot link C object files in fat custom mode." >dev:stderr
	  echo "use -clinkoptPPC <file> and -clinkopt68k <file> instead" >dev:stderr
	  exit 1
	end
    Set objfiles "{objfiles} `quote "{1}"`"
  else if "{1}" == "-c68k"
    set c68k "{2}"
	shift
  else if "{1}" == "-cPPC"
    set cppc "{2}"
	shift
  Else If "{1}" == "-copt68k"
    Set copt68k "{copt68k} {2}"
	Shift
  Else If "{1}" == "-coptPPC"
    Set coptPPC "{coptPPC} {2}"
	Shift
  else if "{1}" == "-clink68k"
    set clink68k "{2}"
	shift
  else if "{1}" == "-clinkPPC"
    set clinkPPC "{2}"
	shift
  else if "{1}" == "-clinkopt68k"
    set clinkopt68k "{clinkopt68k} {2}"
	shift
  else if "{1}" == "-clinkoptPPC"
    set clinkoptPPC "{clinkoptPPC} {2}"
	shift
  else if "{1}" =~ /-/
    echo "Unknown option "{1}", ignored" >dev:stderr
  else
    echo "I don't know what to do with file "{1}", ignored" >dev:stderr
  end
  shift
end

camlrun "{stdlib}provide" -stdlib "{stdlib}" {includes} {perv} >"{tempfile}R"
camlrun "{stdlib}camllink" -stdlib "{stdlib}" {custom} -require "{tempfile}R" 
        -exec "{tempfile}E" -g {includes} stdlib{p}.zo {linkfiles} toplib.zo
camlrun "{stdlib}expunge" {debug} "{tempfile}E" "{output}" sys {perv}
delete -i "{tempfile}R" "{tempfile}E"
setfile -c 'MPS ' -t TEXT "{output}"
if "{customtype}"
  move "{output}" "{tempfile}C"
  If "{customtype}" == fat || "{customtype}" == 68k
	for file in {cfiles}             # including {tempfile}
	  {c68k} -i "{stdlib}includes:" {copt68k} "{file}"
	end
	{clink68k} -c 'MPS ' -t MPST -o "{tempfile}68k" {clinkopt68k} 
		 {objfiles} "{stdlib}libcaml68k.o" 
		 -sg mem=freelist,major_gc,minor_gc,memory,misc,stacks,roots 
		 -sg core=alloc,interp,equal,ints,floats,str,hash,sys,meta,fail,signals,compare 
		 -sg inout=io,extern,extercp,intern,interncp,mac_os,parsing,lexing 
		 -sg misc=main,version,debugcom,gc_ctrl,debugger
  End
  if "{customtype}" == fat || "{customtype}" == PPC
	for file in {cfiles}             # including {tempfile}
	  {cppc} -i "{stdlib}includes:" {coptppc} "{file}"
	end
	{clinkppc} -c 'MPS ' -t MPST -o "{output}" {clinkoptppc} 
		 {objfiles} "{stdlib}libcamlPPC.o"
	rez -a -d PPC_CODE_SIZE="`count -c "{output}"`" "{stdlib}cfrg.r" 
		-o "{output}"
  end
  if "{customtype}" == 68k
	move -y "{tempfile}68k" "{output}"
  else if "{customtype}" == fat
	echo "include "{tempfile}68k";" | rez -a -o "{output}"
  end
  catenate "{tempfile}C" >>"{output}"
  setfile -c 'MPS ' -t MPST "{output}"
  delete -i "{tempfile}68k" "{tempfile}"C "{tempfile}" "{tempfile}".o
end
