(* filename.mlp *)

(**) #open "bool";;
(**) #open "int";;
(**) #open "eq";;
(**) #open "fstring";;
(**) #open "exc";;


let check_suffix name suff =
 string_length name >= string_length suff &
 sub_string name (string_length name - string_length suff) (string_length suff)
    = suff
;;


let chop_suffix name suff =
  let n = string_length name - string_length suff in
  if n < 0 then invalid_arg "chop_suffix" else sub_string name 0 n
;;




let current_dir_name = ":";;

let is_absolute n =
  try
    for i = 0 to string_length n - 1 do
      if nth_char n i == `:` then raise Exit
    done;
    false
  with Exit ->
    true
;;

let concat dirname filename =
  let dirname1 =
    if is_absolute dirname
    then dirname
    else ":" ^ dirname in
  let l =
    string_length dirname1 - 1 in
  let dirname2 =
    if l < 0 or nth_char dirname1 l == `:`
    then dirname1
    else dirname1 ^ ":" in
  let filename2 =
    if string_length filename > 0 & nth_char filename 0 == `:`
    then sub_string filename 1 (string_length filename - 1)
    else filename in
  dirname2 ^ filename2
;;

let colon_pos s =
  let rec pos i =
    if i < 0 then raise Not_found else
    if nth_char s i == `:` then i else pos (i - 1)
  in pos (string_length s - 1)
;;

let basename name =
  try
    let p = colon_pos name + 1 in
      sub_string name p (string_length name - p)
  with Not_found ->
    name
;;

let dirname name =
  if name = ":" then name else
    try
      sub_string name 0 (colon_pos name)
    with Not_found ->
      ":"
;;



