#include <errno.h>
#include <Files.h>
#include <Resources.h>
#include <string.h>
#include <Strings.h>
#include <Types.h>
#ifndef ENOENT
#define ENOENT 1
#endif
#include "mac_os.h"

static short prev_wd = 0;

int chdir (char *dirname)
{
  char buf [256];
  WDPBRec paramblock;

  if (prev_wd != 0){
    paramblock.ioCompletion = NULL;
    paramblock.ioVRefNum = prev_wd;
    PBCloseWD (&paramblock, 0);
  }

  strncpy (buf, dirname, 255);
  buf [255] = 0;
  c2pstr (buf);
  paramblock.ioCompletion = NULL;
  paramblock.ioNamePtr = (StringPtr) buf;
  paramblock.ioVRefNum = 0;
  paramblock.ioWDProcID = 'Caml';
  paramblock.ioWDDirID = 0;
  if (PBOpenWD (&paramblock, 0) != noErr){
    errno = ENOENT;
    return -1;
  }
  prev_wd = paramblock.ioVRefNum;

  paramblock.ioCompletion = NULL;
  paramblock.ioNamePtr = NULL;
  paramblock.ioVRefNum = prev_wd;
  paramblock.ioWDDirID = 0;
  if (PBSetVol ((ParmBlkPtr) &paramblock, 0) != noErr){
    errno = ENOENT;
    return -1;
  }
  return 0;
}

char *searchpath (char *name)
{
  return name;
}

void set_file_type (char *name, long type)
{
  FInfo info;

  GetFInfo ((StringPtr) name, 0, &info);
  info.fdType = type;
  SetFInfo ((StringPtr) name, 0, &info);
}
