definition module tm;

from StdString import String;
    
::	TmState	:== (!Turing, !TrNr, !Comm);
::	Turing	:== (![Trans],!Tape,!State);
::	Trans	:== (!(!State,!Head),!(!State,!Char));
::	Tape	:== (!String,!Int);
::	State	:== String;
::	Head	:== Char;
::	TrNr	:== Int;
::	Comm	=  Erase | None | MoveR1 | MoveR | MoveL | Halt | ErrorL | ErrorT
			|  Write Char;
::	ApState :== (!Tape, !State, !Comm);
::	SeState :== (!TrNr, !Trans);

    
Step	:: TmState -> TmState;
CellContents	:: Int Tape -> Char;
ChangeCellContents	:: Int Tape Char -> Tape;
MoveHead	:: Int Tape -> Tape;
GetTransition	:: Int [Trans] -> Trans;
ChangeTransition	:: Int Trans [Trans] -> [Trans];
RemoveTransition	:: Int [Trans] -> [Trans];
NrOfTransitions	:: [Trans] -> Int;
NrOfCells	:: String -> Int;