module Install

/*
	To completely compile the I/O libraries the memory of the
	Clean 1.1 application should be set to at least 2000 K (use
	Get Info from the File menu of the Finder).

    Make sure the search paths of the Concurrent Clean System
    are set properly, such that at least the following default
    paths are included (use Paths... from the Options menu):

        {Application}:StdEnv:
        {Application}:IOInterface:
        {Application}:MacInterface:

	Pathnames in italics do not lead to the indicated libraries.
	Remove them an add the corresponding libraries to the
	search paths.
    
    Make sure the right processor is chosen by the code generator
    (see Code Generator... in the Options menu).
    
	To generate the object files for the I/O and arithmetic
	libraries choose Bring Up To Date (Commands menu). This may
	take a while (5 to 50 minutes, depending on your Mac).
	
	N.B.: The .obj files that will be generated take about 1 Mb
	      of free disk space.
	
	The folders 'Clean System Files' and the application
	'Install' that will be generated in the Installation folder
	can safely be thrown away after the generation of the object
	files.
	
	It is possible that the error message 'Memory full while
	linking' occurs. This error message can safely be ignored, 
	because the libraries have been already been compiled before
	the linking phase.
*/


import StdEnv

import deltaControls, deltaDialog, deltaEventIO, deltaFileSelect
import deltaFont, deltaIOSystem, deltaIOState, deltaMenu
import deltaPicture, deltaSystem, deltaTimer, deltaWindow


Start :: String
Start = "Compilation of the libraries succeeded."
