system module _SystemArray

/*
	Warnings:

		1)	Arrays get special treatment in the Clean compiler. This
			means that you shouldn't rename the functions declared here,
			and that you shouldn't make other instances of Array
		2)	The structure of this module will change in a future release
*/

class Array a
where

	select				:: ! .(a .e) !Int -> .e 				| select_u e
	uselect				:: ! u:(a e) !Int -> (e, ! u:(a e)) 	| uselect_u e

	size				:: ! .(a .e)  -> Int					| size_u e
	usize				:: ! u:(a .e) -> (!Int, ! u:(a .e))		| usize_u e
	
	update				:: !* (a .e)	!Int .e -> * (a .e)		| update_u e	
	createArray			:: !Int e -> * (a e)					| createArray_u e

instance Array { } default, {!}, {#}

//
// Operation on unboxed arrays
//
class select_u e 		:: !   { #.e } !Int -> .e
class uselect_u e		:: ! u:{ # e } !Int -> (!e, ! u:{ #e })
class size_u e			:: !   { #.e } -> Int
class usize_u e			:: ! u:{ #.e } -> (!Int, ! u:{ #.e })
class update_u e		:: ! * { #.e } !Int !.e -> * { #.e }
class createArray_u e	:: !Int !e -> *{ #e }

class ArrayElem e | select_u, uselect_u, size_u, usize_u, update_u, createArray_u, defaultArrayvalue e

instance select_u		a, Int, Real, Char, Bool, File
instance uselect_u		a, Int, Real, Char, Bool, File
instance size_u			a, Int, Real, Char, Bool, File
instance usize_u		a, Int, Real, Char, Bool, File
instance update_u		a, Int, Real, Char, Bool, File
instance createArray_u	a, Int, Real, Char, Bool, File


class defaultArrayvalue e :: .e

instance defaultArrayvalue Int, Real, Char, Bool, File, a

_abortArray :: a